--[[
  Author: Atrophenus
  Version: 1.2.1
  Description:
    -Plugin to share whatever you are targeting to group, guild, or active channel 
    -As of Version: 1.2.0 new commands to share location and plotted jumps
    -Navshare commands share your location if you have no plotted jump
      otherwise it shares your next jump
    -There is a command to only share your location to group or guild

  Set Up:
      No Set Up necessary simply type in order to use program.
        /sharetargetgroup
        /sharetargetguild
        /sharetargetchannel
        /sharetargetsector
        /navsharesector
        /navsharegroup
        /navshareguild
        /sharelocationgroup
        /sharelocationguild
]]

ShareTarget = {}
ShareTargetFunc = {}

--Creates Rounding funciton
function ShareTargetFunc.Rounding(number)
  if (number - math.floor(number) >= .5) then
    local newnum = math.ceil(number);
    return newnum;
  else 
    local newnum = math.floor(number);
    return newnum;
  end 
end

--Creates the function to share your target to group
function ShareTarget.Sharetargetgroup()
    local name, health, distance, factionid, guild, ship = GetTargetInfo()
    local msg = ""
    local faction = FactionName[factionid]
  
    if name ~= nil then
      local distanceR = ShareTargetFunc.Rounding(distance)
        if health == nil then 
          msg = "Name: "..name.."; Distance: "..distanceR.."m away"
          SendChat(msg, "GROUP")
        else
          local health = ShareTargetFunc.Rounding(health * 100)
          local guildname = "["..guild.."]"..name
          if guild ~= "" then
            msg = "Faction: "..faction.. "; Name: ".. guildname.. ";("..health.."%) Ship: ".. ship.."; Distance: "..distanceR.."m away."
            SendChat(msg, "GROUP")
          else
            msg = "Faction: "..faction.. "; Name: ".. name.. ";("..health.."%) Ship: ".. ship.."; Distance: "..distanceR.."m away."
            SendChat(msg, "GROUP")
          end
        end
    end
end

--Creates the function to share your target to guild
function ShareTarget.Sharetargetguild()
  local name, health, distance, factionid, guild, ship = GetTargetInfo()
  local location = ShortLocationStr(GetCurrentSectorid());
  local msg = ""
  local faction = FactionName[factionid]

  if name ~= nil then
    local distanceR = ShareTargetFunc.Rounding(distance)
      if health == nil then 
        msg = "Name: "..name.."; Distance:"..distanceR.."m away"
        SendChat(msg, "GUILD")
      else
        local health = ShareTargetFunc.Rounding(health * 100)
        local guildname = "["..guild.."]"..name
        if guild ~= "" then
          msg = "Faction: "..faction.. "; Name: ".. guildname.. ";("..health.."%) Ship: ".. ship.."; Distance:"..distanceR.."m away."
          SendChat(msg, "GUILD")
        else
          msg = "Faction: "..faction.. "; Name: ".. name.. ";("..health.."%) Ship: ".. ship.."; Distance: "..distanceR.."m away."
          SendChat(msg, "GUILD")
        end
      end
  end
end

--Creates the function to share your target to your active channel
function ShareTarget.Sharetargetchannel()
  local name, health, distance, factionid, guild, ship = GetTargetInfo()
  local msg = ""
  local faction = FactionName[factionid]

  if name ~= nil then
    local distanceR = ShareTargetFunc.Rounding(distance)
      if health == nil then 
        msg = "Name: "..name.."; Distance: "..distanceR.."m away"
        SendChat(msg, "CHANNEL")
      else
        local health = ShareTargetFunc.Rounding(health * 100)
        local guildname = "["..guild.."]"..name
        if guild ~= "" then
          msg = "Faction: "..faction.. "; Name: ".. guildname.. ";("..health.."%) Ship: ".. ship.."; Distance: "..distanceR.."m away."
          SendChat(msg, "CHANNEL")
        else
          msg = "Faction: "..faction.. "; Name: ".. name.. ";("..health.."%) Ship: ".. ship.."; Distance: "..distanceR.."m away."
          SendChat(msg, "CHANNEL")
        end
      end
  end
end

function ShareTarget.Sharetargetsector()
  local name, health, distance, factionid, guild, ship = GetTargetInfo()
  local msg = ""
  local faction = FactionName[factionid]

  if name ~= nil then
    local distanceR = ShareTargetFunc.Rounding(distance)
      if health == nil then 
        msg = "Name: "..name.."; Distance: "..distanceR.."m away"
        SendChat(msg, "SECTOR")
      else
        local health = ShareTargetFunc.Rounding(health * 100)
        local guildname = "["..guild.."]"..name
        if guild ~= "" then
          msg = "Faction: "..faction.. "; Name: ".. guildname.. ";("..health.."%) Ship: ".. ship.."; Distance: "..distanceR.."m away."
          SendChat(msg, "SECTOR")
        else
          msg = "Faction: "..faction.. "; Name: ".. name.. ";("..health.."%) Ship: ".. ship.."; Distance: "..distanceR.."m away."
          SendChat(msg, "SECOTR")
        end
      end
  end
end

--Creates a navsharegroup function that shares your location to group or your location and next jump to group
function ShareTarget.navsharegroup()
  local systemid = GetCurrentSectorid();
  local nexthopid = NavRoute.GetNextHop();
  -- NavRoute.GetNextHop(); returns current sector id if no navigation is set
  if nexthopid ~= systemid then
    local location = 'Location: '..ShortLocationStr(systemid).."; Next Jump: "..ShortLocationStr(nexthopid)
    SendChat(location, "GROUP")
  else
    local location = 'Location: '..ShortLocationStr(systemid)
    SendChat(location, "GROUP")
  end
end

--Creates a navshareguild function that shares your location to guild or your location and next jump to guild
function ShareTarget.navshareguild()
  local systemid = GetCurrentSectorid();
  local nexthopid = NavRoute.GetNextHop();
  -- NavRoute.GetNextHop(); returns current sector id if no navigation is set
  if nexthopid ~= systemid then
    local location = 'Location: '..ShortLocationStr(systemid).."; Next Jump: "..ShortLocationStr(nexthopid)
    SendChat(location, "GUILD")
  else
    local location = 'Location: '..ShortLocationStr(systemid)
    SendChat(location, "GUILD")
  end
end

function ShareTarget.navsharesector()
  local systemid = GetCurrentSectorid();
  local nexthopid = NavRoute.GetNextHop();
  -- NavRoute.GetNextHop(); returns current sector id if no navigation is set
  if nexthopid ~= systemid then
    local location = 'Location: '..ShortLocationStr(systemid).."; Next Jump: "..ShortLocationStr(nexthopid)
    SendChat(location, "SECTOR")
  else
    local location = 'Location: '..ShortLocationStr(systemid)
    SendChat(location, "SECTOR")
  end
end

--Creates a funciton that only shares your location and not your next jump to guild
function ShareTarget.locationgroup()
  local systemid = GetCurrentSectorid();
  local location = 'Location: '..ShortLocationStr(systemid);
  SendChat(location, "GROUP")  
end

--Creates a function that only shares your locaiton and not your next jump to guild
function ShareTarget.locationguild()
  local systemid = GetCurrentSectorid();
  local location = 'Location: '..ShortLocationStr(systemid);
  SendChat(location, "GUILD")
end

RegisterUserCommand("sharetargetgroup", ShareTarget.Sharetargetgroup)
RegisterUserCommand("sharetargetguild", ShareTarget.Sharetargetguild)
RegisterUserCommand("sharetargetchannel", ShareTarget.Sharetargetchannel)
RegisterUserCommand("sharetargetsector", ShareTarget.Sharetargetsector)
RegisterUserCommand("navsharegroup", ShareTarget.navsharegroup)
RegisterUserCommand("navshareguild", ShareTarget.navshareguild)
RegisterUserCommand("navsharesector", ShareTarget.navsharesector)
RegisterUserCommand("sharelocationgroup", ShareTarget.locationgroup)
RegisterUserCommand("sharelocationguild", ShareTarget.locationguild)